routes/web.php
<?php

use App\Http\Controllers\AddressController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\BrandController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CityController;
use App\Http\Controllers\CKEditorController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\ConsultationController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DiscountController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\MenuController;
use App\Http\Controllers\NewsletterController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\PageController;
use App\Http\Controllers\PaymentController;
use App\Http\Controllers\PostController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProductKeyController;
use App\Http\Controllers\ProductValueController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SearchHistoryController;
use App\Http\Controllers\ShoppingCartController;
use App\Http\Controllers\TicketController;
use App\Http\Controllers\TicketMessageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});


Route::get('/clear-cache', function() {
    $exitCode = Artisan::call('cache:clear');
    // return what you want
});

Auth::routes();

//Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::group(["prefix"=>"panel","as"=>"admin.",'middleware' => ["auth","role:super-admin"]],function (){
    Route::get("/dashboard",[DashboardController::class,"index"])->name("dashboard.index");

    Route::post('/ckeditor/upload',[CKEditorController::class,"upload"])->name("ckeditor.upload");

    // category route
    Route::get('/categories',[CategoryController::class,"index"])->name("categories.index");
    Route::get('/categories/create',[CategoryController::class,"create"])->name("categories.create");
    Route::post('/categories/{category:slug?}',[CategoryController::class,"store"])->name("categories.store");
    Route::get('/categories/{category:slug}/edit',[CategoryController::class,"edit"])->name("categories.edit");
    Route::get('/categories/{category:slug}',[CategoryController::class,"destroy"])->name("categories.destroy");

    // post route
    Route::get('/posts',[PostController::class,"index"])->name("posts.index");
    Route::get('/posts/create',[PostController::class,"create"])->name("posts.create");
    Route::post('/posts/{post:slug?}',[PostController::class,"store"])->name("posts.store");
    Route::get('/posts/{post:slug}/edit',[PostController::class,"edit"])->name("posts.edit");
    Route::get('/posts/{post:slug}',[PostController::class,"destroy"])->name("posts.destroy");

    // comments  route
    Route::get('/comments',[CommentController::class,"index"])->name("comments.index");
    Route::get('/comments/create',[CommentController::class,"create"])->name("comments.create");
    Route::post('/comments/{comment:id?}',[CommentController::class,"store"])->name("comments.store");
    Route::get('/comments/{comment:id}/edit',[CommentController::class,"edit"])->name("comments.edit");
    Route::get('/comments/{comment:id}',[CommentController:: class,"destroy"])->name("comments.destroy");

    // brand route
    Route::get('/brands',[BrandController::class,"index"])->name("brands.index");
    Route::get('/brands/create',[BrandController::class,"create"])->name("brands.create");
    Route::post('/brands/{brand:slug?}',[BrandController::class,"store"])->name("brands.store");
    Route::get('/brands/{brand:slug}/edit',[BrandController::class,"edit"])->name("brands.edit");
    Route::get('/brands/{brand:slug}',[BrandController::class,"destroy"])->name("brands.destroy");

    // product keys route
    Route::get('/keys',[ProductKeyController::class,"index"])->name("keys.index");
    Route::get('/keys/create',[ProductKeyController::class,"create"])->name("keys.create");
    Route::post('/keys/{key:id?}',[ProductKeyController::class,"store"])->name("keys.store");
    Route::get('/keys/{key:id}/edit',[ProductKeyController::class,"edit"])->name("keys.edit");
    Route::get('/keys/{key:id}',[ProductKeyController:: class,"destroy"])->name("keys.destroy");

    // product values route
    Route::get('/values',[ProductValueController::class,"index"])->name("values.index");
    Route::get('/values/create',[ProductValueController::class,"create"])->name("values.create");
    Route::post('/values/{value:id?}',[ProductValueController::class,"store"])->name("values.store");
    Route::get('/values/{value:id}/edit',[ProductValueController::class,"edit"])->name("values.edit");
    Route::get('/values/{value:id}',[ProductValueController:: class,"destroy"])->name("values.destroy");
    Route::get('/ajax-values',[ProductValueController:: class,"getByKeyAjax"])->name("values.by.Key.ajax");

    // product  route
    Route::get('/products',[ProductController::class,"index"])->name("products.index");
    Route::get('/products/create',[ProductController::class,"create"])->name("products.create");
    Route::post('/products/{product:slug?}',[ProductController::class,"store"])->name("products.store");
    Route::get('/products/{product:slug}/edit',[ProductController::class,"edit"])->name("products.edit");
    Route::get('/products/{product:slug}',[ProductController:: class,"destroy"])->name("products.destroy");

    // orders  route
    Route::get('/orders',[OrderController::class,"index"])->name("orders.index");
    Route::get('/orders/create',[OrderController::class,"create"])->name("orders.create");
    Route::post('/orders/{order:id?}',[OrderController::class,"store"])->name("orders.store");
    Route::get('/orders/{order:id}/edit',[OrderController::class,"edit"])->name("orders.edit");
    Route::get('/orders/{order:id}',[OrderController:: class,"destroy"])->name("orders.destroy");
    Route::get('/orders/change-status/{order:id}/{status}',[OrderController:: class,"changeStatus"])->name("orders.change.status");

    Route::get("tickets",[TicketController::class,"index"])->name("ticket.index");
    Route::get("tickets/{ticket:code}",[TicketController::class,"detail"])->name("ticket.detail");
    Route::get("tickets/close/{ticket:code}",[TicketController::class,"close"])->name("ticket.close");
    Route::get("tickets/close/{ticket:code}",[TicketController::class,"close"])->name("ticket.close");

    //menu route
    Route::get("menu",[MenuController::class,"index"])->name("menu.index");
    Route::get("menu/new",[MenuController::class,"create"])->name("menu.create");
    Route::get("menu/edit/{menu:id}",[MenuController::class,"edit"])->name("menu.edit");
    Route::post("menu/new/{menu:id?}",[MenuController::class,"store"])->name("menu.store");
    Route::get("menu/delete/{menu:id}",[MenuController::class,"destroy"])->name("menu.destroy");

    //page route
    Route::get("pages",[PageController::class,"index"])->name("page.index");
    Route::get("pages/new",[PageController::class,"create"])->name("page.create");
    Route::get("pages/edit/{page:slug}",[PageController::class,"edit"])->name("page.edit");
    Route::post("pages/new/{page:slug?}",[PageController::class,"store"])->name("page.store");
    Route::get("pages/delete/{page:slug}",[PageController::class,"destroy"])->name("page.destroy");

    Route::get("consultations",[ConsultationController::class,"index"])->name("consultations.index");
    Route::get("newsletter",[NewsletterController::class,"index"])->name("newsletter.index");
});

Route::group(["prefix"=>"profile","as"=>"profile.",'middleware' => ["auth","role:user"]],function (){
    Route::get("/",[ProfileController::class,"index"])->name("index");
    Route::get("/edit",[ProfileController::class,"profileEdit"])->name("edit");
    Route::post("/getCitiesAjax",[CityController::class,"getCitiesAjax"])->name("cities.ajax");
    Route::post("/update",[ProfileController::class,"updateProfile"])->name("profile.update");
    Route::get("/address",[AddressController::class,"address"])->name("address.index");
    Route::post("/address/create",[AddressController::class,"store"])->name("address.create");
    Route::get("/orders",[OrderController::class,"orderProfile"])->name("order.index");
    Route::get("/orders/{order:refuse_id}",[OrderController::class,"orderProfileDetail"])->name("order.detail");
    Route::get("/tickets",[TicketController::class,"profileTicket"])->name("ticket.index");
    Route::get("/tickets/new",[TicketController::class,"profileNewTicket"])->name("ticket.new");
    Route::get("/tickets/{ticket:code}",[TicketController::class,"profileTicketDetail"])->name("ticket.detail");
    Route::post("/tickets/create",[TicketController::class,"store"])->name("ticket.store");
    Route::post("/tickets-message/create/{ticket:code}",[TicketMessageController::class,"store"])->name("ticket.message.store");
    Route::post('/post/{post:slug}',[PostController::class,"storeComment"])->name("post.comment.store");
    Route::post('/product/{product:slug}',[ProductController::class,"storeComment"])->name("product.comment.store");
    Route::get("/payments",[PaymentController::class,"paymentProfile"])->name("payment.index");

    Route::get('/checkout', [ShoppingCartController::class, 'checkout'])->name('shopping-cart.checkout');
    Route::post('/order/submit', [ShoppingCartController::class, 'SendPayment'])->name('shopping-cart.payment.send');
    Route::get('/verify', [PaymentController::class, 'verify'])->name('payment.verify');

});


Route::group(["middleware" => "redirect"],function (){

app/Http/Controllers/ShoppingCartController.php
<?php

namespace App\Http\Controllers;

use App\Helpers\Zarinpal;
use App\Models\CartItemModel;
use App\Models\CartItemValueModel;
use App\Models\DiscountModel;
use App\Models\ProductDetailModel;
use App\Models\ProductModel;
use App\Services\Address\AddressService;
use App\Services\Order\OrderService;
use App\Services\ProductDetail\ProductDetailService;
use App\Services\ProductValue\ProductValueService;
use App\Services\Province\ProvinceService;
use App\Services\ShoppingCartItem\ShoppingCartItemService;
use App\Services\User\UserService;
use Illuminate\Http\Request;
use App\Models\ShoppingCartModel;
use App\Services\ShoppingCart\ShoppingCartService;
use Illuminate\Support\Facades\App;
use App\Http\Requests\ShoppingCartRequest;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Session;

class ShoppingCartController extends Controller
{

    public ShoppingCartService $shoppingCartService;
    public ProductDetailService $productDetailService;
    public UserService $userService;
    public AddressService $addressService;
    public ProvinceService $provinceService;
    public ShoppingCartItemService $shoppingCartItemService;
    public OrderService $orderService;

    public function __construct()
    {
        $this->shoppingCartService = App::make(ShoppingCartService::class);
        $this->productDetailService = App::make(ProductDetailService::class);
        $this->userService = App::make(UserService::class);
        $this->addressService = App::make(AddressService::class);
        $this->provinceService = App::make(ProvinceService::class);
        $this->shoppingCartItemService = App::make(ShoppingCartItemService::class);
        $this->orderService = App::make(OrderService::class);
    }

    public function index()
    {
        $cartCollection = \Cart::getContent();
        return view('front.shopping-carts.index')->with(['cartCollection' => $cartCollection]);
    }

    public function create()
    {
        return view("panel.shopping-carts.new");
    }

    public function edit(ShoppingCartModel $shoppingCart)
    {
        return view("panel.shopping-carts.edit",compact("shoppingCart"));
    }

    public function store(ShoppingCartRequest $request, ShoppingCartModel $shoppingCart = null)
    {
        $shoppingCartData = $request->all();

        $shoppingCart ? $this->shoppingCartService->save($shoppingCartData,$shoppingCart->id) : $shoppingCart = $this->shoppingCartService->save($shoppingCartData);

        // there is a situation that shopping-cart has not changed, but gallery request changed. this situation ShoppingCartObserver has not performed updated method.
        // so, we should check gallery request in the controller.
        // if request has any gallery then upload it and save to db and sync galleriables
        // and also category request

        if($shoppingCart){
            return redirect()->route('admin.shopping-carts.index')->with('save',true);
        }
        return abort(500);
    }

    public function destroy(Request $request)
    {
        \Cart::remove($request->input("cart-id"));
        return redirect()->route("shopping-cart.index");
    }
    public function addToCart(Request $request,ProductModel $product){
        $totalPrice = 0;
        if($request->has("option"))
        {
            $option = $request->input("option");
            $productDetails = $this->productDetailService->getProductDetailByValue($option,$product);
            $totalPrice = $productDetails->sum("price");
            foreach($productDetails as $detail)
            {
                $row = array();
                $row['option_id'] = $detail->product_value_id;
                $row['option_parent'] = $detail->value->key->id;
                $row['option_name'] = $detail->value->value;
                $row['option_parent_name'] = $detail->value->key->name;
                $row['price'] = $detail->price;
                $attributes['option'][] = $row;
            }
        }
        $attributes['thumbnail'] = $product->thumbnail;
        $attributes['slug'] = $product->slug;
        \Cart::add(array(
            'id' => $product->id,
            'name' => $product->title,
            'price' => $product->price + $totalPrice ,
            'quantity' => 1,
            'attributes' => $attributes
        ));
        return redirect()->route("shopping-cart.index");
    }

    public function update(Request $request)
    {
        \Cart::update($request->id,
            array(
                'quantity' => array(
                    'relative' => false,
                    'value' => $request->quantity
                ),
            ));

        $cartCollection = \Cart::getContent();
        $cartTotalCount = \Cart::getTotalQuantity();

        $percent = 0;
        $percent_struct ='-'.$percent.'%';
        $condition = new \Darryldecode\Cart\CartCondition([
            'name' => 'TAX 12% VAT',
            'type' => 'tax' ,
            'target' => 'total',
            'value' => $percent_struct
        ]);

        $cartTotalDiscount = \Cart::getSubTotal() - \Cart::getTotal();
        $cartTotal =  \Cart::getTotal();
        $conditions = \Cart::getConditions()->put($condition->getName(), $condition)->toArray();
        \Cart::condition($conditions);
        return response()->json([$cartCollection,$cartTotal,$cartTotalCount,$cartTotalDiscount]);
    }

    public function checkout()
    {
        $user = $this->userService->getMe();
        $address = $this->addressService->get(["user_id","=",$user->id]);
        $provinces = $this->provinceService->all();
        return view("front.shopping-carts.checkout",compact("user","address","provinces"));
    }

    public function sendPayment(Request $request)
    {
        $user = $this->userService->getMe();
        $shoppingCartData = $request->all();
        $shoppingCartData["total_price"] = \Cart::getTotal();
//        $shoppingCartData["discount_code"] = "code";
        $shoppingCartData["user_id"] = $user->id;

        // save shopping-cart & shopping-cart-item & shopping-cart-item-value
        $shoppingCart = $this->shoppingCartService->save($shoppingCartData);
        $this->shoppingCartItemService->save($shoppingCart);

        // save order
        $orderData = $request->all();
        $orderData["refuse_id"] = 123123;
        $orderData["shopping_cart_id"] = $shoppingCart->id;
        $orderData["tracking_code"] = "IRK75465";
        $orderData["user_id"] = $user->id;
        $this->orderService->save($orderData);

        //send to payment
        if($request->input("payment_type") == 1){ // Zarinpal
            $zarinpal = new zarinpal();
            $res = $zarinpal->pay($shoppingCart->total_price,$user->email,$user->mobile);
            return redirect('https://www.zarinpal.com/pg/StartPay/' . $res);
        }
    }
}

resources/views/front/shopping-carts/checkout.blade.php
@extends("layouts.front.riode")
@section("header")
    <meta name="csrf-token" content="{{ csrf_token() }}">
    <link rel="stylesheet" type="text/css" href="{{ asset("front/demo4/css/demo4.min.css") }}">
    <link rel="stylesheet" type="text/css" href="{{ asset("front/demo4/css/style.min.css") }}">
    <title>سبد خرید</title>
    <style>
        textarea{height:145px;resize:none}
        .price{
            font-weight: 700;
            font-size: 1.6rem;
            color: #222;
        }
        .product-price{display: table-cell}
        .product-remove {
            text-align: left;
            font-size: 1.2rem;
            width: 2.3rem;
            height: 2.3rem;
            border: 1px solid #ccc;
            border-radius: 50%;
            background-color: #fff;
            color: #222;
            cursor: pointer;
        }
        .shop-table{
            width: 100%;
        }
        .shop-table thead,.shop-table tbody tr{
            border-bottom:1px solid #e1e1e1;
        }
        .shop-table thead th{
            padding:1.5em 0;
        }
        .shop-table tbody tr td{
            padding: 1em;
        }
        .shop-table tbody tr td:last-child{
            padding-left: 0;
        }
    </style>
@endsection
@section("content")
    <div class="page-content mt-6">
        <form action="{{ route("profile.shopping-cart.payment.send") }}" method="post">
            @csrf
            <div class="container">
                <div class="row">
                    <div class="col-md-8">
                        @include("profile.partials.notifications")
                        <h3 class="title title-simple text-right text-uppercase">اطلاعات تحویل گیرنده </h3>
                        <div class="row">
                            <div class="col-xs-6 mb-4">
                                <label for="first-name">نام <b class="red-star">*</b></label>
                                <input type="text" value="{{$user->name}}" class="form-control" name="receiver_name" id="first-name" required=""/>
                            </div>
                            <div class="col-xs-6 mb-4">
                                <label for="last-name">نام خانوادگی <b class="red-star">*</b></label>
                                <input type="text"  value="{{$user->family}}" class="form-control" id="last-name" name="receiver_family" required=""/>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 mb-4">
                                <label for="province">استان <b class="red-star">*</b></label>
                                <select name="province" class="form-control city" id="province">
                                    @foreach($provinces as $province)
                                        <option @if($province->id == $user->province) selected @endif value="{{$province->id}}">{{$province->name}}</option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="col-xs-6 mb-4">
                                <label>شهر<b class="red-star">*</b></label>
                                <div class="">
                                    <select name="city_id" class="form-control" id="city">
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 mb-4">
                                <label for="address-select">آدرس محل تحویل <b class="red-star">*</b></label>
                                @if($address->count() > 0)
                                    <select name="receiver_address" class="form-control" id="address-select">
                                        @foreach($address as $item)
                                            <option value="{{ $item->id }}">{{ $item->address }}</option>
                                        @endforeach
                                    </select>
                                @else
                                    <input type="text"  value="{{$user->address}}" class="form-control" id="address-select" name="receiver_address" required=""
                                           placeholder=""/>
                                @endif
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6">
                                <label>کد پستی <b class="red-star">*</b></label>
                                <input type="text" value="{{$user->postal_code}}" class="form-control postal_code" name="receiver_postal_code" required=""/>
                            </div>
                            <div class="col-xs-6">
                                <label>کد ملی <b class="red-star">*</b></label>
                                <input type="text" value="{{$user->national_code}}" class="form-control national_code" name="receiver_national_code" required=""/>
                            </div>
                            <div class="col-12 mt-4">
                                <p>در مورد زمان تحویل کالا، یا توضیحات ویژگی های خاص محصول مدنظر شما، می توانید این قسمت را پر کنید.</p>
                                <label for="description">توضیحات</label>
                                <textarea class="form-control" id="description" name="description" placeholder="توضیحات"></textarea>
                            </div>
                        </div>
                    </div>
                    <aside class="col-md-4 sticky-sidebar-wrapper">
                        <div class="sticky-sidebar" data-sticky-options="{'bottom': 20}">
                            <div class="summary mb-4">
                                <h4 class="">روش پرداخت</h4>
                                <div class="payment accordion radio-type">
                                    <div class="custom-radio mb-6">
                                        <input checked type="radio" name="payment-method" value="1" id="payment-method">
                                        <label for="payment-method">زرین پال (درگاه واسط بانکی)</label>
                                    </div>
                                </div>
                                <hr>
                                <h5 class="mt-4 mb-2">زمان تحویل</h5>
                                <p><strong>تهران: </strong> حداکثر 24 ساعت بعد از سفارش</p>
                                <p><strong>شهرستان ها: </strong> حداکثر 48 ساعت بعد از سفارش</p>
                                <hr>
                                <table class="shipping">
                                    <tr class="summary-subtotal" style="border-bottom: none;">
                                        <td>
                                            <h4 class="summary-subtitle">قیمت کالا ها</h4>
                                        </td>
                                        <td>
                                            <span class="summary-subtotal-price" id="total_amount">{{ number_format (\Cart::getSubTotal())}} </span><span class="price"> تومان </span>
                                        </td>
                                    </tr>
                                    <tr class="summary-subtotal">
                                        <td>
                                            <h4 class="summary-subtitle">تخفیف کالاها</h4>
                                        </td>
                                        <td>
                                                    <span class="summary-subtotal-price" id="total_amount_discount">{{ number_format(\Cart::getSubTotal() - \Cart::getTotal())}}
                                                        </span><span class="price"> تومان </span>
                                        </td>
                                    </tr>
                                </table>
                                <table class="total">
                                    <tr class="summary-subtotal">
                                        <td>
                                            <h4 class="summary-subtitle">مبلغ قابل پرداخت</h4>
                                        </td>
                                        <td>
                                                    <span class="summary-total-price ls-s" id="total_amount_after_discount">{{ number_format(\Cart::getTotal()) }}
                                                        </span><span class="price"> تومان </span>
                                        </td>
                                    </tr>
                                </table>
                                <button type="submit" class="btn btn-primary btn-rounded btn-checkout mt-5 btn-block">ثبت سفارش و پرداخت</button>
                            </div>
                        </div>
                    </aside>
                </div>
            </div>
        </form>
    </div>
@endsection
@section("script")
    <script>
        let province = {{ $user->province }};
        $(document).ready(function (){
            $.ajax({
                type:'POST',
                url:"{{ route("profile.cities.ajax") }}",
                beforeSend: function() {
                    $("#loading").show();
                },
                data: {
                    "_token": "{{ csrf_token() }}",
                    "province_id": province
                },
                success:function(data) {
                    $("#loading").hide();
                    $("#city").html(data).find("option[value='{{ $user->city }}']").attr("selected",true);
                }
            });
        });
        $(document).on("change","#province",(function( event ) {
            province = $(this).val();
            $.ajax({
                type:'GET',
                url:"{{ route("profile.cities.ajax") }}",
                beforeSend: function() {
                    $("#loading").show();
                },
                data: {
                    "_token": "{{ csrf_token() }}",
                    "province_id": province
                },
                success:function(data) {
                    $("#loading").hide();
                    $("#city").html(data);
                }
            });
        }));
    </script>
@endsection

resources/views/front/shopping-carts/cities-dropdown.blade.php
@foreach($cities as $city)
<option value="{{ $city->id }}">{{ $city->name }}</option>
@endforeach